(set-logic QF_NIA)
(set-info
  :source |
SMT script generated by Ultimate LassoRanker [1].
Ultimate LassoRanker is a tool that analyzes termination and nontermination of 
lasso-shaped programs. This script contains the SMT commands that Ultimate 
LassoRanker used while checking if a lasso-shaped program has a geometric 
nontermination argument [2].

This SMT script belongs to a set of SMT scripts that was generated by applying
Ultimate Buchi Automizer [3,4] to the benchmarks from the SV-COMP 2015 [5,6] 
which are available at [7]. Ultimate Buchi Automizer takes omega-traces
(lasso-shaped programs) and uses LassoRanker in order to check if the 
lasso-shaped program is terminating.

2015-04-30, Matthias Heizmann (heizmann@informatik.uni-freiburg.de)


[1] https://ultimate.informatik.uni-freiburg.de/LassoRanker/
[2] Jan Leike, Matthias Heizmann:
Geometric Series as Nontermination Arguments for Linear Lasso Programs. 
CoRR abs/1405.4413 (2014)
http://arxiv.org/abs/1405.4413
[3] http://ultimate.informatik.uni-freiburg.de/BuchiAutomizer/
[4] Matthias Heizmann, Jochen Hoenicke, Andreas Podelski: Software Model 
Checking for People Who Love Automata. CAV 2013:36-52
[5] http://sv-comp.sosy-lab.org/2015/
[6] Dirk Beyer: Software Verification and Verifiable Witnesses - (Report on 
SV-COMP 2015). TACAS 2015: 401-416
[7] https://svn.sosy-lab.org/software/sv-benchmarks/tags/svcomp15/
|)
(set-info :smt-lib-version 2.0)
(set-info :category "industrial")
(set-info :status unsat)
(declare-fun init_cstrstr_~c~6 () Int)
(declare-fun honda_cstrstr_~c~6 () Int)
(declare-fun ray_cstrstr_~c~6 () Int)
(declare-fun init_cstrstr_~find.offset () Int)
(declare-fun honda_cstrstr_~find.offset () Int)
(declare-fun ray_cstrstr_~find.offset () Int)
(declare-fun init_cstrstr_~sc~6 () Int)
(declare-fun honda_cstrstr_~sc~6 () Int)
(declare-fun ray_cstrstr_~sc~6 () Int)
(declare-fun |init_cstrstr_#t~mem12| () Int)
(declare-fun |honda_cstrstr_#t~mem12| () Int)
(declare-fun |ray_cstrstr_#t~mem12| () Int)
(declare-fun |init_(select #length cstrstr_~s.base)| () Int)
(declare-fun |honda_(select #length cstrstr_~s.base)| () Int)
(declare-fun |ray_(select #length cstrstr_~s.base)| () Int)
(declare-fun |init_cstrstr_#t~ret13| () Int)
(declare-fun |honda_cstrstr_#t~ret13| () Int)
(declare-fun |ray_cstrstr_#t~ret13| () Int)
(declare-fun |init_cstrstr_#t~post15.base| () Int)
(declare-fun |honda_cstrstr_#t~post15.base| () Int)
(declare-fun |ray_cstrstr_#t~post15.base| () Int)
(declare-fun |init_cstrstr_#t~post15.offset| () Int)
(declare-fun |honda_cstrstr_#t~post15.offset| () Int)
(declare-fun |ray_cstrstr_#t~post15.offset| () Int)
(declare-fun
  |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| ()
  Int)
(declare-fun
  |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| ()
  Int)
(declare-fun
  |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| ()
  Int)
(declare-fun |init_cstrstr_#t~post11.offset| () Int)
(declare-fun |honda_cstrstr_#t~post11.offset| () Int)
(declare-fun |ray_cstrstr_#t~post11.offset| () Int)
(declare-fun |init_cstrstr_#in~find.base| () Int)
(declare-fun |honda_cstrstr_#in~find.base| () Int)
(declare-fun |ray_cstrstr_#in~find.base| () Int)
(declare-fun |init_cstrstr_#in~find.offset| () Int)
(declare-fun |honda_cstrstr_#in~find.offset| () Int)
(declare-fun |ray_cstrstr_#in~find.offset| () Int)
(declare-fun |init_#NULL.offset| () Int)
(declare-fun |honda_#NULL.offset| () Int)
(declare-fun |ray_#NULL.offset| () Int)
(declare-fun |init_(ite (select #valid cstrstr_~s.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid cstrstr_~s.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstrstr_~s.base) 1 0)| () Int)
(declare-fun |init_cstrstr_#t~post11.base| () Int)
(declare-fun |honda_cstrstr_#t~post11.base| () Int)
(declare-fun |ray_cstrstr_#t~post11.base| () Int)
(declare-fun init_cstrstr_~find.base () Int)
(declare-fun honda_cstrstr_~find.base () Int)
(declare-fun ray_cstrstr_~find.base () Int)
(declare-fun |init_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid 0) 1 0)| () Int)
(declare-fun |init_cstrstr_#in~s.offset| () Int)
(declare-fun |honda_cstrstr_#in~s.offset| () Int)
(declare-fun |ray_cstrstr_#in~s.offset| () Int)
(declare-fun init_cstrstr_~s.offset () Int)
(declare-fun honda_cstrstr_~s.offset () Int)
(declare-fun ray_cstrstr_~s.offset () Int)
(declare-fun |init_cstrstr_#t~mem16| () Int)
(declare-fun |honda_cstrstr_#t~mem16| () Int)
(declare-fun |ray_cstrstr_#t~mem16| () Int)
(declare-fun init_cstrstr_~s.base () Int)
(declare-fun honda_cstrstr_~s.base () Int)
(declare-fun ray_cstrstr_~s.base () Int)
(declare-fun init_cstrstr_~len~6 () Int)
(declare-fun honda_cstrstr_~len~6 () Int)
(declare-fun ray_cstrstr_~len~6 () Int)
(declare-fun |init_#NULL.base| () Int)
(declare-fun |honda_#NULL.base| () Int)
(declare-fun |ray_#NULL.base| () Int)
(declare-fun |init_cstrstr_#in~s.base| () Int)
(declare-fun |honda_cstrstr_#in~s.base| () Int)
(declare-fun |ray_cstrstr_#in~s.base| () Int)
(declare-fun
  |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
  () Int)
(declare-fun |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| ()
  Int)
(declare-fun
  |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
  () Int)
(declare-fun |honda_(select #length cstrstr_#in~find.base)| () Int)
(declare-fun |ray_(select #length cstrstr_#in~find.base)| () Int)
(declare-fun |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
  () Int)
(declare-fun
  |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
  () Int)
(declare-fun
  |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
  () Int)
(declare-fun |honda_(select old(#length) cstrstr_#in~s.base)| () Int)
(declare-fun |ray_(select old(#length) cstrstr_#in~s.base)| () Int)
(declare-fun |honda_(select old(#length) cstrstr_#in~find.base)| () Int)
(declare-fun |ray_(select old(#length) cstrstr_#in~find.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| ()
  Int)
(declare-fun |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| () Int)
(declare-fun |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| () Int)
(declare-fun |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| () Int)
(declare-fun |honda_(select #length cstrstr_#in~s.base)| () Int)
(declare-fun |ray_(select #length cstrstr_#in~s.base)| () Int)
(declare-fun |honda_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun |ray_(ite (select old(#valid) 0) 1 0)| () Int)
(declare-fun
  |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
  () Int)
(declare-fun
  |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
  () Int)
(declare-fun
  |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
  () Int)
(declare-fun
  |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)| ()
  Int)
(declare-fun lambda () Int)
(declare-fun aux_5138 () Int)
(declare-fun aux_5140 () Int)
(declare-fun aux_5145 () Int)
(declare-fun aux_5147 () Int)
(declare-fun aux_5152 () Int)
(declare-fun aux_5154 () Int)
(declare-fun aux_5159 () Int)
(declare-fun aux_5161 () Int)
(declare-fun aux_5166 () Int)
(declare-fun aux_5168 () Int)
(declare-fun aux_5173 () Int)
(declare-fun aux_5175 () Int)
(declare-fun aux_5180 () Int)
(declare-fun aux_5182 () Int)
(declare-fun aux_5187 () Int)
(declare-fun aux_5189 () Int)
(declare-fun aux_5194 () Int)
(declare-fun aux_5196 () Int)
(declare-fun aux_5201 () Int)
(declare-fun aux_5203 () Int)
(declare-fun aux_5208 () Int)
(declare-fun aux_5210 () Int)
(declare-fun aux_5215 () Int)
(declare-fun aux_5217 () Int)
(declare-fun aux_5222 () Int)
(declare-fun aux_5224 () Int)
(declare-fun aux_5229 () Int)
(declare-fun aux_5231 () Int)
(declare-fun aux_5236 () Int)
(declare-fun aux_5238 () Int)
(declare-fun aux_5243 () Int)
(declare-fun aux_5245 () Int)
(declare-fun aux_5250 () Int)
(declare-fun aux_5252 () Int)
(declare-fun aux_5257 () Int)
(declare-fun aux_5259 () Int)
(declare-fun aux_5264 () Int)
(declare-fun aux_5266 () Int)
(declare-fun aux_5271 () Int)
(declare-fun aux_5273 () Int)
(declare-fun aux_5278 () Int)
(declare-fun aux_5280 () Int)
(declare-fun aux_5285 () Int)
(declare-fun aux_5287 () Int)
(declare-fun aux_5292 () Int)
(declare-fun aux_5294 () Int)
(declare-fun aux_5299 () Int)
(declare-fun aux_5301 () Int)
(declare-fun aux_5306 () Int)
(declare-fun aux_5308 () Int)
(declare-fun aux_5313 () Int)
(declare-fun aux_5315 () Int)
(declare-fun aux_5320 () Int)
(declare-fun aux_5322 () Int)
(declare-fun aux_5327 () Int)
(declare-fun aux_5329 () Int)
(declare-fun aux_5334 () Int)
(declare-fun aux_5336 () Int)
(declare-fun aux_5341 () Int)
(declare-fun aux_5343 () Int)
(declare-fun aux_5348 () Int)
(declare-fun aux_5350 () Int)
(declare-fun aux_5355 () Int)
(declare-fun aux_5357 () Int)
(declare-fun aux_5362 () Int)
(declare-fun aux_5364 () Int)
(declare-fun aux_5369 () Int)
(declare-fun aux_5371 () Int)
(declare-fun aux_5376 () Int)
(declare-fun aux_5378 () Int)
(declare-fun aux_5383 () Int)
(declare-fun aux_5385 () Int)
(declare-fun aux_5390 () Int)
(declare-fun aux_5392 () Int)
(declare-fun aux_5397 () Int)
(declare-fun aux_5399 () Int)
(declare-fun aux_5404 () Int)
(declare-fun aux_5406 () Int)
(declare-fun aux_5411 () Int)
(declare-fun aux_5413 () Int)
(declare-fun aux_5418 () Int)
(declare-fun aux_5420 () Int)
(declare-fun aux_5425 () Int)
(declare-fun aux_5427 () Int)
(declare-fun aux_5432 () Int)
(declare-fun aux_5434 () Int)
(declare-fun aux_5439 () Int)
(declare-fun aux_5441 () Int)
(declare-fun aux_5446 () Int)
(declare-fun aux_5448 () Int)
(declare-fun aux_5453 () Int)
(declare-fun aux_5455 () Int)
(declare-fun aux_5460 () Int)
(declare-fun aux_5462 () Int)
(declare-fun aux_5467 () Int)
(declare-fun aux_5469 () Int)
(declare-fun aux_5474 () Int)
(declare-fun aux_5476 () Int)
(declare-fun aux_5481 () Int)
(declare-fun aux_5483 () Int)
(declare-fun aux_5488 () Int)
(declare-fun aux_5490 () Int)
(declare-fun aux_5495 () Int)
(declare-fun aux_5497 () Int)
(declare-fun aux_5502 () Int)
(declare-fun aux_5504 () Int)
(declare-fun aux_5509 () Int)
(declare-fun aux_5511 () Int)
(declare-fun aux_5516 () Int)
(declare-fun aux_5518 () Int)
(declare-fun aux_5523 () Int)
(declare-fun aux_5525 () Int)
(declare-fun aux_5530 () Int)
(declare-fun aux_5532 () Int)
(declare-fun aux_5537 () Int)
(declare-fun aux_5539 () Int)
(declare-fun aux_5544 () Int)
(declare-fun aux_5546 () Int)
(declare-fun aux_5551 () Int)
(declare-fun aux_5553 () Int)
(declare-fun aux_5558 () Int)
(declare-fun aux_5560 () Int)
(declare-fun aux_5565 () Int)
(declare-fun aux_5567 () Int)
(declare-fun aux_5572 () Int)
(declare-fun aux_5574 () Int)
(declare-fun aux_5579 () Int)
(declare-fun aux_5581 () Int)
(declare-fun aux_5586 () Int)
(declare-fun aux_5588 () Int)
(declare-fun aux_5593 () Int)
(declare-fun aux_5595 () Int)
(declare-fun aux_5600 () Int)
(declare-fun aux_5602 () Int)
(declare-fun aux_5607 () Int)
(declare-fun aux_5609 () Int)
(declare-fun aux_5614 () Int)
(declare-fun aux_5616 () Int)
(declare-fun aux_5621 () Int)
(declare-fun aux_5623 () Int)
(declare-fun aux_5628 () Int)
(declare-fun aux_5630 () Int)
(declare-fun aux_5635 () Int)
(declare-fun aux_5637 () Int)
(declare-fun aux_5642 () Int)
(declare-fun aux_5644 () Int)
(declare-fun aux_5648 () Int)
(declare-fun aux_5650 () Int)
(declare-fun aux_5654 () Int)
(declare-fun aux_5656 () Int)
(declare-fun aux_5660 () Int)
(declare-fun aux_5662 () Int)
(declare-fun aux_5666 () Int)
(declare-fun aux_5668 () Int)
(declare-fun aux_5672 () Int)
(declare-fun aux_5674 () Int)
(declare-fun aux_5678 () Int)
(declare-fun aux_5680 () Int)
(declare-fun aux_5684 () Int)
(declare-fun aux_5686 () Int)
(declare-fun aux_5690 () Int)
(declare-fun aux_5692 () Int)
(declare-fun aux_5696 () Int)
(declare-fun aux_5698 () Int)
(declare-fun aux_5702 () Int)
(declare-fun aux_5704 () Int)
(declare-fun aux_5708 () Int)
(declare-fun aux_5710 () Int)
(declare-fun aux_5714 () Int)
(declare-fun aux_5716 () Int)
(declare-fun aux_5720 () Int)
(declare-fun aux_5722 () Int)
(declare-fun aux_5726 () Int)
(declare-fun aux_5728 () Int)
(declare-fun aux_5732 () Int)
(declare-fun aux_5734 () Int)
(declare-fun aux_5738 () Int)
(declare-fun aux_5740 () Int)
(declare-fun aux_5744 () Int)
(declare-fun aux_5746 () Int)
(declare-fun aux_5750 () Int)
(declare-fun aux_5752 () Int)
(declare-fun aux_5756 () Int)
(declare-fun aux_5758 () Int)
(declare-fun aux_5762 () Int)
(declare-fun aux_5764 () Int)
(declare-fun aux_5768 () Int)
(declare-fun aux_5770 () Int)
(declare-fun aux_5774 () Int)
(declare-fun aux_5776 () Int)
(declare-fun aux_5780 () Int)
(declare-fun aux_5782 () Int)
(declare-fun aux_5786 () Int)
(declare-fun aux_5788 () Int)
(declare-fun aux_5792 () Int)
(declare-fun aux_5794 () Int)
(declare-fun aux_5798 () Int)
(declare-fun aux_5800 () Int)
(declare-fun aux_5804 () Int)
(declare-fun aux_5806 () Int)
(declare-fun aux_5810 () Int)
(declare-fun aux_5812 () Int)
(declare-fun aux_5816 () Int)
(declare-fun aux_5818 () Int)
(declare-fun aux_5822 () Int)
(declare-fun aux_5824 () Int)
(declare-fun aux_5828 () Int)
(declare-fun aux_5830 () Int)
(declare-fun aux_5834 () Int)
(declare-fun aux_5836 () Int)
(declare-fun aux_5840 () Int)
(declare-fun aux_5842 () Int)
(declare-fun aux_5846 () Int)
(declare-fun aux_5848 () Int)
(declare-fun aux_5852 () Int)
(declare-fun aux_5854 () Int)
(declare-fun aux_5858 () Int)
(declare-fun aux_5860 () Int)
(declare-fun aux_5864 () Int)
(declare-fun aux_5866 () Int)
(declare-fun aux_5870 () Int)
(declare-fun aux_5872 () Int)
(declare-fun aux_5876 () Int)
(declare-fun aux_5878 () Int)
(declare-fun aux_5882 () Int)
(declare-fun aux_5884 () Int)
(declare-fun aux_5888 () Int)
(declare-fun aux_5890 () Int)
(declare-fun aux_5894 () Int)
(declare-fun aux_5896 () Int)
(declare-fun aux_5900 () Int)
(declare-fun aux_5902 () Int)
(declare-fun aux_5906 () Int)
(declare-fun aux_5908 () Int)
(declare-fun aux_5912 () Int)
(declare-fun aux_5914 () Int)
(declare-fun aux_5918 () Int)
(declare-fun aux_5920 () Int)
(declare-fun aux_5924 () Int)
(declare-fun aux_5926 () Int)
(declare-fun aux_5930 () Int)
(declare-fun aux_5932 () Int)
(declare-fun aux_5936 () Int)
(declare-fun aux_5938 () Int)
(declare-fun aux_5942 () Int)
(declare-fun aux_5944 () Int)
(declare-fun aux_5948 () Int)
(declare-fun aux_5950 () Int)
(declare-fun aux_5954 () Int)
(declare-fun aux_5956 () Int)
(declare-fun aux_5960 () Int)
(declare-fun aux_5962 () Int)
(declare-fun aux_5966 () Int)
(declare-fun aux_5968 () Int)
(declare-fun aux_5972 () Int)
(declare-fun aux_5974 () Int)
(declare-fun aux_5978 () Int)
(declare-fun aux_5980 () Int)
(declare-fun aux_5984 () Int)
(declare-fun aux_5986 () Int)
(declare-fun aux_5990 () Int)
(declare-fun aux_5992 () Int)
(declare-fun aux_5996 () Int)
(declare-fun aux_5998 () Int)
(declare-fun aux_6002 () Int)
(declare-fun aux_6004 () Int)
(declare-fun aux_6008 () Int)
(declare-fun aux_6010 () Int)
(declare-fun aux_6014 () Int)
(declare-fun aux_6016 () Int)
(declare-fun aux_6020 () Int)
(declare-fun aux_6022 () Int)
(declare-fun aux_6026 () Int)
(declare-fun aux_6028 () Int)
(declare-fun aux_6032 () Int)
(declare-fun aux_6034 () Int)
(declare-fun aux_6038 () Int)
(declare-fun aux_6040 () Int)
(declare-fun aux_6044 () Int)
(declare-fun aux_6046 () Int)
(declare-fun aux_6050 () Int)
(declare-fun aux_6052 () Int)
(declare-fun aux_6056 () Int)
(declare-fun aux_6058 () Int)
(declare-fun aux_6062 () Int)
(declare-fun aux_6064 () Int)
(declare-fun aux_6068 () Int)
(declare-fun aux_6070 () Int)
(assert
 (and
 (or
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5138 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5138 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5140 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5138 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5140 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5140 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5138 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5145 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5145 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5147 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5145 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5147 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5147 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5145 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5152 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5152 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5154 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5152 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5154 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5154 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5152 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5159 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5159 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5161 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5159 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5161 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5161 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5159 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5166 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5166 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5168 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5166 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5168 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5168 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5166 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5173 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5173 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5175 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5173 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5175 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5175 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5173 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5180 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5180 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5182 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5180 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5182 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5182 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5180 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5187 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5187 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5189 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5187 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5189 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5189 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5187 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5194 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5194 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5196 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5194 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5196 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5196 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5194 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5201 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5201 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5203 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5201 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5203 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5203 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5201 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5208 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5208 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5210 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5208 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5210 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5210 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5208 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5215 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5215 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5217 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5215 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5217 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5217 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5215 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5222 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5222 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5224 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5222 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5224 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5224 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5222 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5229 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5229 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5231 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5229 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5231 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5231 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5229 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5236 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5236 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5238 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5236 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5238 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5238 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5236 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5243 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5243 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5245 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5243 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5245 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5245 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5243 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5250 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5250 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5252 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5250 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5252 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5252 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5250 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5257 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5257 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5259 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5257 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5259 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5259 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5257 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5264 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5264 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5266 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5264 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5266 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5266 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5264 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5271 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5271 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5273 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5271 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5273 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5273 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5271 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5278 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5278 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5280 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5278 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5280 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5280 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5278 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5285 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5285 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5287 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5285 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5287 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5287 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5285 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5292 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5292 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5294 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5292 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5294 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5294 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5292 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5299 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5299 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5301 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5299 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5301 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5301 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5299 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5306 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5306 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5308 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5306 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5308 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5308 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5306 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5313 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5313 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5315 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5313 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5315 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5315 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5313 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5320 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5320 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5322 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5320 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5322 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5322 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5320 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5327 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5327 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5329 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5327 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5329 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5329 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5327 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5334 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5334 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5336 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5334 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5336 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5336 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5334 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5341 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5341 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5343 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5341 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5343 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5343 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5341 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5348 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5348 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5350 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5348 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5350 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5350 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5348 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5355 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5355 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5357 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5355 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5357 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5357 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5355 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5362 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5362 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5364 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5362 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5364 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5364 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5362 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5369 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5369 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5371 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5369 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5371 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5371 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5369 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5376 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5376 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5378 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5376 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5378 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5378 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5376 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5383 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5383 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5385 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5383 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5385 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5385 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5383 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5390 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5390 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5392 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5390 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5392 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5392 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5390 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5397 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5397 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5399 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5397 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5399 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5399 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5397 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5404 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5404 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5406 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5404 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5406 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5406 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5404 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5411 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5411 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5413 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5411 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5413 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5413 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5411 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5418 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5418 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5420 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5418 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5420 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5420 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5418 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5425 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5425 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5427 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5425 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5427 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5427 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5425 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5432 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5432 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5434 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5432 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5434 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5434 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5432 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5439 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5439 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5441 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5439 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5441 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5441 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5439 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5446 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5446 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5448 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5446 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5448 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5448 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5446 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5453 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5453 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5455 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5453 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5455 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5455 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5453 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5460 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5460 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5462 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5460 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5462 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5462 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5460 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5467 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5467 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5469 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5467 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5469 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5469 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5467 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5474 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5474 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5476 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5474 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5476 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5476 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5474 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5481 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5481 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5483 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5481 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5483 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5483 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5481 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5488 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5488 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5490 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5488 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5490 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5490 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5488 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5495 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5495 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5497 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5495 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5497 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5497 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5495 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5502 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5502 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5504 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5502 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5504 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5504 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5502 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5509 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5509 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5511 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5509 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5511 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5511 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5509 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5516 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5516 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5518 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5516 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5518 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5518 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5516 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5523 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5523 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5525 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5523 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5525 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5525 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5523 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5530 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5530 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5532 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5530 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5532 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5532 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5530 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5537 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5537 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5539 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5537 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5539 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5539 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5537 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5544 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5544 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5546 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5544 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5546 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5546 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5544 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5551 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5551 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5553 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5551 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5553 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5553 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5551 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5558 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5558 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5560 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5558 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5560 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5560 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5558 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5565 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5565 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5567 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5565 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5567 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5567 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5565 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5572 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5572 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5574 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5572 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5574 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5574 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5572 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5579 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5579 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5581 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5579 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5581 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5581 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5579 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5586 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5586 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5588 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5586 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5588 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5588 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5586 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5593 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5593 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5595 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5593 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5595 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5595 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5593 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5600 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5600 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5602 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5600 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5602 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5602 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5600 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5607 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5607 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5609 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5607 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5609 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5609 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5607 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5614 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5614 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5616 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5614 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5616 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5616 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5614 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5621 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5621 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5623 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5621 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5623 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5623 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5621 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5628 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5628 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5630 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5628 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5630 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5630 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5628 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5635 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5635 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5637 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5635 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5637 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5637 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5635 (- 1)) 2) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5642 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5642 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5644 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5642 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5644 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5644 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5648 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5648 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5650 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5648 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5650 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5650 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5654 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5654 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5656 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5654 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5656 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5656 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5660 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5660 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5662 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5660 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5662 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5662 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5666 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5666 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5668 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5666 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5668 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5668 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5672 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5672 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5674 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5672 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5674 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5674 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5678 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5678 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5680 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5678 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5680 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5680 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5684 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5684 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5686 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5684 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5686 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5686 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5690 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5690 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5692 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5690 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5692 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5692 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5696 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5696 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5698 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5696 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5698 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5698 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5702 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5702 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5704 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5702 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5704 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5704 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5708 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5708 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5710 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5708 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5710 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5710 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5714 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5714 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5716 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5714 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5716 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5716 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5720 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5720 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5722 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5720 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5722 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5722 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5726 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5726 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5728 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5726 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5728 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5728 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5732 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5732 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5734 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5732 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5734 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5734 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5738 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5738 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5740 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5738 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5740 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5740 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5744 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5744 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5746 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5744 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5746 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5746 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5750 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5750 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5752 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5750 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5752 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5752 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5756 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5756 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5758 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5756 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5758 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5758 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5762 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5762 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5764 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5762 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5764 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5764 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5768 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5768 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5770 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5768 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5770 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5770 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5774 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5774 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5776 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5774 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5776 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5776 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5780 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5780 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5782 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5780 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5782 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5782 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5786 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5786 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5788 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5786 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5788 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5788 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5792 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5792 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5794 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5792 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5794 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5794 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5798 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5798 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5800 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5798 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5800 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5800 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5804 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5804 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5806 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5804 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5806 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5806 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5810 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5810 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5812 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5810 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5812 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5812 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5816 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5816 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5818 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5816 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5818 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5818 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5822 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5822 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5824 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5822 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5824 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5824 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5828 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5828 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5830 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5828 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5830 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5830 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5834 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5834 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5836 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5834 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5836 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5836 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5840 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5840 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5842 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5840 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5842 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5842 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5846 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5846 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5848 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5846 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5848 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5848 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5852 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5852 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5854 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5852 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5854 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5854 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5858 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5858 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5860 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5858 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5860 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5860 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5864 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5864 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5866 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5864 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5866 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5866 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5870 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5870 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5872 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5870 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5872 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5872 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5876 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5876 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5878 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5876 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5878 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5878 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5882 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5882 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5884 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5882 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5884 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5884 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5888 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5888 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5890 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5888 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5890 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5890 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5894 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5894 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5896 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5894 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5896 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5896 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5900 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5900 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5902 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5900 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5902 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5902 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5906 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5906 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5908 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5906 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5908 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5908 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5912 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5912 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5914 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5912 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5914 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5914 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5918 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5918 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5920 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5918 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5920 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5920 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5924 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5924 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5926 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5924 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5926 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5926 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5930 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5930 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5932 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5930 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5932 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5932 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5936 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5936 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5938 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5936 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5938 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5938 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5942 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5942 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5944 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5942 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5944 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5944 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5948 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5948 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5950 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5948 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5950 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5950 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5954 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5954 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5956 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5954 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5956 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5956 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5960 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5960 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5962 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5960 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5962 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5962 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5966 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5966 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5968 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5966 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5968 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5968 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5972 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5972 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5974 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5972 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5974 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5974 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5978 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5978 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5980 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5978 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5980 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5980 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5984 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5984 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5986 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5984 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5986 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5986 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5990 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5990 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5992 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5990 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5992 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5992 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5996 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5996 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5998 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5996 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5998 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_5998 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6002 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6002 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6004 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6002 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6004 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6004 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6008 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6008 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6010 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6008 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6010 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6010 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6014 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6014 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6016 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6014 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6016 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6016 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6020 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6020 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6022 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6020 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6022 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6022 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6026 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6026 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6028 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6026 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6028 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6028 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6032 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6032 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6034 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6032 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6034 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6034 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6038 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6038 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6040 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6038 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6040 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6040 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6044 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6044 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6046 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6044 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6046 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6046 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6050 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6050 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6052 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6050 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6052 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6052 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6056 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6056 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6058 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6056 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6058 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6058 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6062 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6062 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6064 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6062 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6064 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6064 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0))
 (and
 (= |init_(select #length cstrstr_~s.base)|
 |honda_(select #length cstrstr_~s.base)|)
 (= |init_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|)
 (= |init_(ite (select #valid cstrstr_~s.base) 1 0)|
 |honda_(ite (select #valid cstrstr_~s.base) 1 0)|)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base (- 1))
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| (- 1))
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6068 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 1)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6068 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 1)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6070 (- 1)) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 1)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| (- 1))
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 1)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#in~find.base| 0)
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 1) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6068 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (- 1)) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 1) 
 (* honda_cstrstr_~s.offset (- 1))
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 1)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 1) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 (- 1)) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 1)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| (- 1))
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6070 1) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| (- 1)) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (* aux_6070 1) (- 2)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 1) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 (- 1))
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 1) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (- 1)) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 1) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| (- 1))
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| (- 1)) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| (- 1))
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base (- 1))
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 1) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 (- 1))
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 1) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 1)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| (- 1)) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 1)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| (- 1)) 
 (* honda_cstrstr_~s.offset 1)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 
 (- 1)) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (- 1)) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 1) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 1) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 1) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (- 1)) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)
 (>=
 (+ (* |honda_(select #length cstrstr_~s.base)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_cstrstr_#t~post15.offset| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* |honda_cstrstr_#t~post11.offset| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 0) (* |honda_cstrstr_#in~find.base| 0) 
 (* |honda_cstrstr_#t~post11.base| 0)
 (* |honda_(ite (select #valid 0) 1 0)| 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* |honda_cstrstr_#in~s.offset| 0) 
 (* honda_cstrstr_~s.offset 0)
 (* |honda_(select #length cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem16| 0)
 (* |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* honda_cstrstr_~s.base 0)
 (*
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 0) (* |honda_(select old(#length) cstrstr_#in~s.base)| 0)
 (* |honda_cstrstr_#in~s.base| 0) 
 (* honda_cstrstr_~c~6 0) 
 (* honda_cstrstr_~find.offset 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(select old(#length) cstrstr_#in~find.base)| 0)
 (* |honda_cstrstr_#t~mem12| 0) 
 (* |honda_cstrstr_#t~ret13| 0)
 (* |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)| 0)
 (* |honda_cstrstr_#in~find.offset| 0) 
 (* |honda_#NULL.offset| 1)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0)
 (* honda_cstrstr_~find.base 0)
 (* |honda_(select #length cstrstr_#in~s.base)| 0)
 (* |honda_(ite (select old(#valid) 0) 1 0)| 0)
 (*
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 0) (* honda_cstrstr_~len~6 0)
 (*
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 0) (* |honda_#NULL.base| 0) 
 (* init_cstrstr_~c~6 0) (* init_cstrstr_~find.offset 0)
 (* init_cstrstr_~sc~6 0) 
 (* |init_cstrstr_#t~mem12| 0) 
 (* |init_cstrstr_#t~ret13| 0) 
 (* |init_cstrstr_#t~post15.base| 0) 
 (* |init_cstrstr_#t~post15.offset| 0) 
 (* |init_cstrstr_#t~post11.offset| 0) 
 (* |init_cstrstr_#in~find.base| 0) 
 (* |init_cstrstr_#in~find.offset| 0) 
 (* |init_#NULL.offset| 0) 
 (* |init_cstrstr_#t~post11.base| 0) 
 (* init_cstrstr_~find.base 0) 
 (* |init_(ite (select #valid 0) 1 0)| 0) 
 (* |init_cstrstr_#in~s.offset| 0) 
 (* init_cstrstr_~s.offset 0) 
 (* |init_cstrstr_#t~mem16| 0) 
 (* init_cstrstr_~s.base 0) 
 (* init_cstrstr_~len~6 0) 
 (* |init_#NULL.base| 0) (* |init_cstrstr_#in~s.base| 0) 0) 0)))
 (or
 (and
 (=
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#t~post11.offset|
 (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#in~find.base|
 (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|))
 (= |honda_cstrstr_#t~post11.base|
 (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= |honda_cstrstr_#in~s.offset|
 (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|))
 (= |honda_(select #length cstrstr_#in~find.base)|
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|))
 (= |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|))
 (= |honda_(select old(#length) cstrstr_#in~s.base)|
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|))
 (= |honda_cstrstr_#in~s.base|
 (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|))
 (= honda_cstrstr_~c~6 (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6))
 (= honda_cstrstr_~find.offset
 (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset))
 (= |honda_cstrstr_#t~mem12|
 (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|))
 (= |honda_(select old(#length) cstrstr_#in~find.base)|
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|))
 (= |honda_cstrstr_#t~ret13|
 (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|))
 (= |honda_cstrstr_#in~find.offset|
 (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_cstrstr_~find.base
 (+ honda_cstrstr_~find.base ray_cstrstr_~find.base))
 (= |honda_(select #length cstrstr_#in~s.base)|
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= honda_cstrstr_~len~6 (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6))
 (=
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| (- 1))
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) (- 1))
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 1) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 1)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 1) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) (- 1))
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 1) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 
 (- 1))
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 1)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 1)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (=
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#t~post11.offset| (* |ray_cstrstr_#t~post11.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#in~find.base| (* |ray_cstrstr_#in~find.base| lambda))
 (= |ray_cstrstr_#t~post11.base| (* |ray_cstrstr_#t~post11.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda))
 (= |ray_cstrstr_#in~s.offset| (* |ray_cstrstr_#in~s.offset| lambda))
 (= |ray_(select #length cstrstr_#in~find.base)|
 (* |ray_(select #length cstrstr_#in~find.base)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (= |ray_(select old(#length) cstrstr_#in~s.base)|
 (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda))
 (= |ray_cstrstr_#in~s.base| (* |ray_cstrstr_#in~s.base| lambda))
 (= ray_cstrstr_~c~6 (* ray_cstrstr_~c~6 lambda))
 (= ray_cstrstr_~find.offset (* ray_cstrstr_~find.offset lambda))
 (= |ray_cstrstr_#t~mem12| (* |ray_cstrstr_#t~mem12| lambda))
 (= |ray_(select old(#length) cstrstr_#in~find.base)|
 (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda))
 (= |ray_cstrstr_#t~ret13| (* |ray_cstrstr_#t~ret13| lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_cstrstr_#in~find.offset| (* |ray_cstrstr_#in~find.offset| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_cstrstr_~find.base (* ray_cstrstr_~find.base lambda))
 (= |ray_(select #length cstrstr_#in~s.base)|
 (* |ray_(select #length cstrstr_#in~s.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda)) (= ray_cstrstr_~len~6 (* ray_cstrstr_~len~6 lambda))
 (= |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| (- 1))
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0)
 (* (* ray_cstrstr_~c~6 lambda) (- 1))
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base (- 1)) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 1)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 1)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) (- 1))
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 1) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) (- 1))
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 1)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 1)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 1) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0) 
 (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#t~post11.offset|
 (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#in~find.base|
 (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|))
 (= |honda_cstrstr_#t~post11.base|
 (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= |honda_cstrstr_#in~s.offset|
 (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|))
 (= |honda_(select #length cstrstr_#in~find.base)|
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|))
 (= |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|))
 (= |honda_(select old(#length) cstrstr_#in~s.base)|
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|))
 (= |honda_cstrstr_#in~s.base|
 (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|))
 (= honda_cstrstr_~c~6 (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6))
 (= honda_cstrstr_~find.offset
 (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset))
 (= |honda_cstrstr_#t~mem12|
 (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|))
 (= |honda_(select old(#length) cstrstr_#in~find.base)|
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|))
 (= |honda_cstrstr_#t~ret13|
 (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|))
 (= |honda_cstrstr_#in~find.offset|
 (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_cstrstr_~find.base
 (+ honda_cstrstr_~find.base ray_cstrstr_~find.base))
 (= |honda_(select #length cstrstr_#in~s.base)|
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= honda_cstrstr_~len~6 (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6))
 (=
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| (- 1))
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 1) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 1)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 1) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) (- 1))
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 1) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 
 (- 1))
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 1)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 1)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 1)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (=
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#t~post11.offset| (* |ray_cstrstr_#t~post11.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#in~find.base| (* |ray_cstrstr_#in~find.base| lambda))
 (= |ray_cstrstr_#t~post11.base| (* |ray_cstrstr_#t~post11.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda))
 (= |ray_cstrstr_#in~s.offset| (* |ray_cstrstr_#in~s.offset| lambda))
 (= |ray_(select #length cstrstr_#in~find.base)|
 (* |ray_(select #length cstrstr_#in~find.base)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (= |ray_(select old(#length) cstrstr_#in~s.base)|
 (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda))
 (= |ray_cstrstr_#in~s.base| (* |ray_cstrstr_#in~s.base| lambda))
 (= ray_cstrstr_~c~6 (* ray_cstrstr_~c~6 lambda))
 (= ray_cstrstr_~find.offset (* ray_cstrstr_~find.offset lambda))
 (= |ray_cstrstr_#t~mem12| (* |ray_cstrstr_#t~mem12| lambda))
 (= |ray_(select old(#length) cstrstr_#in~find.base)|
 (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda))
 (= |ray_cstrstr_#t~ret13| (* |ray_cstrstr_#t~ret13| lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_cstrstr_#in~find.offset| (* |ray_cstrstr_#in~find.offset| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_cstrstr_~find.base (* ray_cstrstr_~find.base lambda))
 (= |ray_(select #length cstrstr_#in~s.base)|
 (* |ray_(select #length cstrstr_#in~s.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda)) (= ray_cstrstr_~len~6 (* ray_cstrstr_~len~6 lambda))
 (= |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| (- 1))
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base (- 1)) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 1)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 1)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) (- 1))
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 1) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) (- 1))
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 1)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 1)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 1) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 1) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0) 
 (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#t~post11.offset|
 (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#in~find.base|
 (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|))
 (= |honda_cstrstr_#t~post11.base|
 (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= |honda_cstrstr_#in~s.offset|
 (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|))
 (= |honda_(select #length cstrstr_#in~find.base)|
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|))
 (= |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|))
 (= |honda_(select old(#length) cstrstr_#in~s.base)|
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|))
 (= |honda_cstrstr_#in~s.base|
 (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|))
 (= honda_cstrstr_~c~6 (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6))
 (= honda_cstrstr_~find.offset
 (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset))
 (= |honda_cstrstr_#t~mem12|
 (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|))
 (= |honda_(select old(#length) cstrstr_#in~find.base)|
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|))
 (= |honda_cstrstr_#t~ret13|
 (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|))
 (= |honda_cstrstr_#in~find.offset|
 (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_cstrstr_~find.base
 (+ honda_cstrstr_~find.base ray_cstrstr_~find.base))
 (= |honda_(select #length cstrstr_#in~s.base)|
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= honda_cstrstr_~len~6 (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6))
 (=
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| (- 1))
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) (- 1))
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 1) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 1)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 1) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) (- 1))
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 1) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 
 (- 1))
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 1)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 1)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (=
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#t~post11.offset| (* |ray_cstrstr_#t~post11.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#in~find.base| (* |ray_cstrstr_#in~find.base| lambda))
 (= |ray_cstrstr_#t~post11.base| (* |ray_cstrstr_#t~post11.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda))
 (= |ray_cstrstr_#in~s.offset| (* |ray_cstrstr_#in~s.offset| lambda))
 (= |ray_(select #length cstrstr_#in~find.base)|
 (* |ray_(select #length cstrstr_#in~find.base)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (= |ray_(select old(#length) cstrstr_#in~s.base)|
 (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda))
 (= |ray_cstrstr_#in~s.base| (* |ray_cstrstr_#in~s.base| lambda))
 (= ray_cstrstr_~c~6 (* ray_cstrstr_~c~6 lambda))
 (= ray_cstrstr_~find.offset (* ray_cstrstr_~find.offset lambda))
 (= |ray_cstrstr_#t~mem12| (* |ray_cstrstr_#t~mem12| lambda))
 (= |ray_(select old(#length) cstrstr_#in~find.base)|
 (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda))
 (= |ray_cstrstr_#t~ret13| (* |ray_cstrstr_#t~ret13| lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_cstrstr_#in~find.offset| (* |ray_cstrstr_#in~find.offset| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_cstrstr_~find.base (* ray_cstrstr_~find.base lambda))
 (= |ray_(select #length cstrstr_#in~s.base)|
 (* |ray_(select #length cstrstr_#in~s.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda)) (= ray_cstrstr_~len~6 (* ray_cstrstr_~len~6 lambda))
 (= |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| (- 1))
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0)
 (* (* ray_cstrstr_~c~6 lambda) (- 1))
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base (- 1)) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 1)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 1)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) (- 1))
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 1) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) (- 1))
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 1)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 1)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 1) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0) 
 (= lambda lambda))
 (and
 (=
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#t~post11.offset|
 (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|))
 (= |honda_cstrstr_#in~find.base|
 (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|))
 (= |honda_cstrstr_#t~post11.base|
 (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|))
 (= |honda_(ite (select #valid 0) 1 0)|
 (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= |honda_cstrstr_#in~s.offset|
 (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|))
 (= |honda_(select #length cstrstr_#in~find.base)|
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|))
 (= |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|))
 (=
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|))
 (= |honda_(select old(#length) cstrstr_#in~s.base)|
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|))
 (= |honda_cstrstr_#in~s.base|
 (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|))
 (= honda_cstrstr_~c~6 (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6))
 (= honda_cstrstr_~find.offset
 (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset))
 (= |honda_cstrstr_#t~mem12|
 (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|))
 (= |honda_(select old(#length) cstrstr_#in~find.base)|
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|))
 (= |honda_cstrstr_#t~ret13|
 (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|))
 (= |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|))
 (= |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|))
 (= |honda_cstrstr_#in~find.offset|
 (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|))
 (= |honda_#NULL.offset| (+ |honda_#NULL.offset| |ray_#NULL.offset|))
 (= honda_cstrstr_~find.base
 (+ honda_cstrstr_~find.base ray_cstrstr_~find.base))
 (= |honda_(select #length cstrstr_#in~s.base)|
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|))
 (= |honda_(ite (select old(#valid) 0) 1 0)|
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|))
 (=
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|))
 (= honda_cstrstr_~len~6 (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6))
 (=
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|))
 (= |honda_#NULL.base| (+ |honda_#NULL.base| |ray_#NULL.base|))
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| (- 1))
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 1)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 1)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base (- 1)) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 1) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 1)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset (- 1)) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 1) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) (- 1))
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 1) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 1) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 
 (- 1))
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 1)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 1)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 1)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) (- 1))
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) (- 1))
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 0)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 1) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 0) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 
 (- 1)) 0)
 (>=
 (+
 (*
 (+
 |honda_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#t~post15.offset| |ray_cstrstr_#t~post15.offset|) 0)
 (* (+ |honda_cstrstr_#t~post15.base| |ray_cstrstr_#t~post15.base|) 0)
 (*
 (+ |honda_(select #length cstrstr_~s.base)|
 |ray_(select #length cstrstr_~s.base)|) 0)
 (* (+ |honda_cstrstr_#t~post11.offset| |ray_cstrstr_#t~post11.offset|) 0)
 (*
 (+ |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|)
 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|)
 0) (* (+ |honda_cstrstr_#in~find.base| |ray_cstrstr_#in~find.base|) 0)
 (* (+ |honda_cstrstr_#t~post11.base| |ray_cstrstr_#t~post11.base|) 0)
 (* (+ |honda_(ite (select #valid 0) 1 0)| |ray_(ite (select #valid 0) 1 0)|)
 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ |honda_cstrstr_#in~s.offset| |ray_cstrstr_#in~s.offset|) 0)
 (* (+ honda_cstrstr_~s.offset ray_cstrstr_~s.offset) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~find.base)|
 |ray_(select #length cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~mem16| |ray_cstrstr_#t~mem16|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|)
 0) (* (+ honda_cstrstr_~s.base ray_cstrstr_~s.base) 0)
 (*
 (+
 |honda_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|)
 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~s.base)|
 |ray_(select old(#length) cstrstr_#in~s.base)|) 0)
 (* (+ |honda_cstrstr_#in~s.base| |ray_cstrstr_#in~s.base|) 0)
 (* (+ honda_cstrstr_~c~6 ray_cstrstr_~c~6) 0)
 (* (+ honda_cstrstr_~find.offset ray_cstrstr_~find.offset) 0)
 (* (+ honda_cstrstr_~sc~6 ray_cstrstr_~sc~6) 1)
 (* (+ |honda_cstrstr_#t~mem12| |ray_cstrstr_#t~mem12|) 0)
 (*
 (+ |honda_(select old(#length) cstrstr_#in~find.base)|
 |ray_(select old(#length) cstrstr_#in~find.base)|) 0)
 (* (+ |honda_cstrstr_#t~ret13| |ray_cstrstr_#t~ret13|) 0)
 (*
 (+ |honda_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|) 0)
 (* (+ |honda_cstrstr_#in~find.offset| |ray_cstrstr_#in~find.offset|) 0)
 (* (+ |honda_#NULL.offset| |ray_#NULL.offset|) 0)
 (*
 (+ |honda_(ite (select #valid cstrstr_~s.base) 1 0)|
 |ray_(ite (select #valid cstrstr_~s.base) 1 0)|) 0)
 (* (+ honda_cstrstr_~find.base ray_cstrstr_~find.base) 0)
 (*
 (+ |honda_(select #length cstrstr_#in~s.base)|
 |ray_(select #length cstrstr_#in~s.base)|) 0)
 (*
 (+ |honda_(ite (select old(#valid) 0) 1 0)|
 |ray_(ite (select old(#valid) 0) 1 0)|) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|)
 0) (* (+ honda_cstrstr_~len~6 ray_cstrstr_~len~6) 0)
 (*
 (+
 |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|) 0)
 (* (+ |honda_#NULL.base| |ray_#NULL.base|) 0)
 (* |honda_cstrstr_#t~post15.offset| 0) 
 (* |honda_cstrstr_#t~post15.base| 0)
 (* |honda_(select #length cstrstr_~s.base)| 0)
 (* |honda_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* honda_cstrstr_~s.offset 0) 
 (* |honda_cstrstr_#t~mem16| 0) 
 (* honda_cstrstr_~s.base 0) 
 (* honda_cstrstr_~sc~6 0)
 (* |honda_(ite (select #valid cstrstr_~s.base) 1 0)| 0) 0) 0)
 (=
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#t~post11.offset| (* |ray_cstrstr_#t~post11.offset| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda))
 (= |ray_cstrstr_#in~find.base| (* |ray_cstrstr_#in~find.base| lambda))
 (= |ray_cstrstr_#t~post11.base| (* |ray_cstrstr_#t~post11.base| lambda))
 (= |ray_(ite (select #valid 0) 1 0)|
 (* |ray_(ite (select #valid 0) 1 0)| lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda))
 (= |ray_cstrstr_#in~s.offset| (* |ray_cstrstr_#in~s.offset| lambda))
 (= |ray_(select #length cstrstr_#in~find.base)|
 (* |ray_(select #length cstrstr_#in~find.base)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (=
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda))
 (= |ray_(select old(#length) cstrstr_#in~s.base)|
 (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda))
 (= |ray_cstrstr_#in~s.base| (* |ray_cstrstr_#in~s.base| lambda))
 (= ray_cstrstr_~c~6 (* ray_cstrstr_~c~6 lambda))
 (= ray_cstrstr_~find.offset (* ray_cstrstr_~find.offset lambda))
 (= |ray_cstrstr_#t~mem12| (* |ray_cstrstr_#t~mem12| lambda))
 (= |ray_(select old(#length) cstrstr_#in~find.base)|
 (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda))
 (= |ray_cstrstr_#t~ret13| (* |ray_cstrstr_#t~ret13| lambda))
 (= |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)|
 (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda))
 (= |ray_cstrstr_#in~find.offset| (* |ray_cstrstr_#in~find.offset| lambda))
 (= |ray_#NULL.offset| (* |ray_#NULL.offset| lambda))
 (= ray_cstrstr_~find.base (* ray_cstrstr_~find.base lambda))
 (= |ray_(select #length cstrstr_#in~s.base)|
 (* |ray_(select #length cstrstr_#in~s.base)| lambda))
 (= |ray_(ite (select old(#valid) 0) 1 0)|
 (* |ray_(ite (select old(#valid) 0) 1 0)| lambda))
 (=
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda)) (= ray_cstrstr_~len~6 (* ray_cstrstr_~len~6 lambda))
 (= |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda)) (= |ray_#NULL.base| (* |ray_#NULL.base| lambda))
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| (- 1))
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 1)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 1)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base (- 1)) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 1)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 1)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset (- 1)) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 1)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) (- 1))
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 1) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) (- 1))
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 1)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 1)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 1) 
 (* (* ray_cstrstr_~find.offset lambda) 0)
 (* (* ray_cstrstr_~sc~6 lambda) (- 1))
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) (- 1))
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 0) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 1) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)| 0)
 (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0)
 (>=
 (+
 (*
 (*
 |ray_(select (select #memory_int cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#t~post15.offset| lambda) 0)
 (* (* |ray_cstrstr_#t~post15.base| lambda) 0)
 (* (* |ray_(select #length cstrstr_~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.offset| lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_#in~find.base) cstrstr_#in~find.offset)|
 lambda) 0) (* (* |ray_cstrstr_#in~find.base| lambda) 0)
 (* (* |ray_cstrstr_#t~post11.base| lambda) 0)
 (* (* |ray_(ite (select #valid 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* |ray_cstrstr_#in~s.offset| lambda) 0)
 (* (* ray_cstrstr_~s.offset lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~mem16| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~find.base) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* ray_cstrstr_~s.base lambda) 0)
 (*
 (*
 |ray_(select (select old(#memory_int) cstrstr_~find.base) cstrstr_~find.offset)|
 lambda) 0) (* (* |ray_(select old(#length) cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_cstrstr_#in~s.base| lambda) 0) 
 (* (* ray_cstrstr_~c~6 lambda) 0) 
 (* (* ray_cstrstr_~find.offset lambda) 0) 
 (* (* ray_cstrstr_~sc~6 lambda) 1) 
 (* (* |ray_cstrstr_#t~mem12| lambda) 0)
 (* (* |ray_(select old(#length) cstrstr_#in~find.base)| lambda) 0)
 (* (* |ray_cstrstr_#t~ret13| lambda) 0)
 (* (* |ray_(ite (select old(#valid) cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_#in~s.base) 1 0)| lambda) 0)
 (* (* |ray_cstrstr_#in~find.offset| lambda) 0)
 (* (* |ray_#NULL.offset| lambda) 0)
 (* (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| lambda) 0)
 (* (* ray_cstrstr_~find.base lambda) 0)
 (* (* |ray_(select #length cstrstr_#in~s.base)| lambda) 0)
 (* (* |ray_(ite (select old(#valid) 0) 1 0)| lambda) 0)
 (*
 (*
 |ray_(select (select #memory_int cstrstr_~find.base) (+ 1 cstrstr_~find.offset))|
 lambda) 0) (* (* ray_cstrstr_~len~6 lambda) 0)
 (*
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_#in~s.offset)|
 lambda) 0) (* (* |ray_#NULL.base| lambda) 0)
 (* |ray_cstrstr_#t~post15.offset| 0) 
 (* |ray_cstrstr_#t~post15.base| 0)
 (* |ray_(select #length cstrstr_~s.base)| 0)
 (* |ray_(select (select #memory_int cstrstr_~s.base) cstrstr_~s.offset)|
 (- 1)) (* ray_cstrstr_~s.offset 0) 
 (* |ray_cstrstr_#t~mem16| 0) 
 (* ray_cstrstr_~s.base 0) 
 (* ray_cstrstr_~sc~6 0)
 (* |ray_(ite (select #valid cstrstr_~s.base) 1 0)| 0)) 0) 
 (= lambda lambda))) (>= lambda 0)))
(check-sat)
(exit)

